diff -Naur dbus-1.8.2/bus/bus.c dbus-1.8.2.new/bus/bus.c
--- dbus-1.8.2/bus/bus.c	2014-01-25 13:39:24.000000000 +0100
+++ dbus-1.8.2.new/bus/bus.c	2014-09-23 10:27:23.257354352 +0200
@@ -1237,6 +1237,12 @@
 }
 
 int
+bus_context_get_pending_fd_timeout (BusContext *context)
+{
+  return context->limits.pending_fd_timeout;
+}
+
+int
 bus_context_get_max_completed_connections (BusContext *context)
 {
   return context->limits.max_completed_connections;
diff -Naur dbus-1.8.2/bus/bus.h dbus-1.8.2.new/bus/bus.h
--- dbus-1.8.2/bus/bus.h	2014-01-25 13:39:24.000000000 +0100
+++ dbus-1.8.2.new/bus/bus.h	2014-09-23 10:27:23.257354352 +0200
@@ -54,6 +54,7 @@
   long max_message_unix_fds;        /**< Max number of unix fds of a single message*/
   int activation_timeout;           /**< How long to wait for an activation to time out */
   int auth_timeout;                 /**< How long to wait for an authentication to time out */
+  int pending_fd_timeout;           /**< How long to wait for a D-Bus message with a fd to time out */
   int max_completed_connections;    /**< Max number of authorized connections */
   int max_incomplete_connections;   /**< Max number of incomplete connections */
   int max_connections_per_user;     /**< Max number of connections auth'd as same user */
@@ -106,6 +107,7 @@
                                                                   DBusError        *error);
 int               bus_context_get_activation_timeout             (BusContext       *context);
 int               bus_context_get_auth_timeout                   (BusContext       *context);
+int               bus_context_get_pending_fd_timeout             (BusContext       *context);
 int               bus_context_get_max_completed_connections      (BusContext       *context);
 int               bus_context_get_max_incomplete_connections     (BusContext       *context);
 int               bus_context_get_max_connections_per_user       (BusContext       *context);
diff -Naur dbus-1.8.2/bus/config-parser.c dbus-1.8.2.new/bus/config-parser.c
--- dbus-1.8.2/bus/config-parser.c	2014-01-25 13:39:24.000000000 +0100
+++ dbus-1.8.2.new/bus/config-parser.c	2014-09-23 10:27:23.259354413 +0200
@@ -439,6 +439,11 @@
        * password) is allowed, then potentially it has to be quite long.
        */
       parser->limits.auth_timeout = 30000; /* 30 seconds */
+
+      /* Do not allow a fd to stay forever in dbus-daemon
+       * https://bugs.freedesktop.org/show_bug.cgi?id=80559
+       */
+      parser->limits.pending_fd_timeout = 150000; /* 2.5 minutes */
       
       parser->limits.max_incomplete_connections = 64;
       parser->limits.max_connections_per_user = 256;
@@ -1902,6 +1907,12 @@
       must_be_int = TRUE;
       parser->limits.auth_timeout = value;
     }
+  else if (strcmp (name, "pending_fd_timeout") == 0)
+    {
+      must_be_positive = TRUE;
+      must_be_int = TRUE;
+      parser->limits.pending_fd_timeout = value;
+    }
   else if (strcmp (name, "reply_timeout") == 0)
     {
       must_be_positive = TRUE;
@@ -3108,6 +3119,7 @@
      || a->max_message_unix_fds == b->max_message_unix_fds
      || a->activation_timeout == b->activation_timeout
      || a->auth_timeout == b->auth_timeout
+     || a->pending_fd_timeout == b->pending_fd_timeout
      || a->max_completed_connections == b->max_completed_connections
      || a->max_incomplete_connections == b->max_incomplete_connections
      || a->max_connections_per_user == b->max_connections_per_user
diff -Naur dbus-1.8.2/bus/session.conf.in dbus-1.8.2.new/bus/session.conf.in
--- dbus-1.8.2/bus/session.conf.in	2014-01-25 13:39:24.000000000 +0100
+++ dbus-1.8.2.new/bus/session.conf.in	2014-09-23 10:27:23.260354443 +0200
@@ -52,6 +52,7 @@
   <limit name="max_message_unix_fds">@DEFAULT_MESSAGE_UNIX_FDS@</limit>
   <limit name="service_start_timeout">120000</limit>  
   <limit name="auth_timeout">240000</limit>
+  <limit name="pending_fd_timeout">150000</limit>
   <limit name="max_completed_connections">100000</limit>  
   <limit name="max_incomplete_connections">10000</limit>
   <limit name="max_connections_per_user">100000</limit>
diff -Naur dbus-1.8.2/doc/dbus-daemon.1.xml.in dbus-1.8.2.new/doc/dbus-daemon.1.xml.in
--- dbus-1.8.2/doc/dbus-daemon.1.xml.in	2014-01-25 13:39:25.000000000 +0100
+++ dbus-1.8.2.new/doc/dbus-daemon.1.xml.in	2014-09-23 10:32:49.405155595 +0200
@@ -528,6 +528,10 @@
       "auth_timeout"               : milliseconds (thousandths) a
                                      connection is given to
                                      authenticate
+      "pending_fd_timeout"         : milliseconds (thousandths) a
+                                     fd is given to be transmitted to
+                                     dbus-daemon before disconnecting the
+                                     connection
       "max_completed_connections"  : max number of authenticated connections
       "max_incomplete_connections" : max number of unauthenticated
                                      connections
